#!/usr/bin/env python

XML = """<?xml version="1.0" encoding="utf-8"?>
<executable>

  <category>Demonstration </category>
  <title>Python HelloPython</title>
  <description> Slicer developer course in Python
</description>
  <version>1.0</version>
  
  <license></license>
  <contributor> This module was developed by Sonia Pujol, Ph.D., Harvard University. </contributor>
 <documentation-url> http://www.slicer.org/slicerWiki/index.php/Slicer3.6:Training </documentation-url>
 <acknowledgements>
            This work is part of the National Alliance for Medical Image Computing (NA-MIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149. </acknowledgements>

  <parameters>
    <label>Input/Output</label>
    <description>Input/output parameters</description>
    <image>
      <name>HelloPythonInputVolume</name>
      <label>Input Volume</label>
      <channel>input</channel>
      <index>0</index>
      <description>input volume</description>
    </image>
    <image>
      <name>HelloPythonOutputVolume</name>
      <label>Output Volume</label>
      <channel>output</channel>
      <index>1</index>
      <description>output volume</description>
    </image>
  </parameters>
<parameters>
    <label>Hello Python Parameters</label>
    <description>Parameters of the Python Hello Python module </description>
     <integer>
      <name>dimensionality</name>
      <longflag>dimensionality</longflag>
      <description>Dimensionality of the Laplace operator</description>
      <label>Dimensionality</label>
      <default>3</default>
      <constraints>
        <minimum>2</minimum>
        <maximum>3</maximum>
      </constraints>
    </integer>
</parameters>


</executable>
"""



def Execute (HelloPythonInputVolume, HelloPythonOutputVolume, dimensionality=3):
	Slicer = __import__("Slicer")
        slicer = Slicer.slicer
	scene = slicer.MRMLScene
	inputVolume = scene.GetNodeByID(HelloPythonInputVolume)
	outputVolume = scene.GetNodeByID(HelloPythonOutputVolume)
	laplacian = slicer.vtkImageLaplacian()
	laplacian.SetInput(inputVolume.GetImageData())
	laplacian.SetDimensionality(dimensionality)
	laplacian.Update()
	outputVolume.SetAndObserveImageData(laplacian.GetOutput())
	matrix = slicer.vtkMatrix4x4()
	inputVolume.GetIJKToRASMatrix(matrix)
	outputVolume.SetIJKToRASMatrix(matrix)
	return

